/* LSAGPI                                       */
/* Desarrollado por Miguel Angel Pescador Santirso  */
/* mescadorsantirso@gmail.com                       */

/* LICENCIA X11/MIT
Copyright (c) 2010 Miguel Angel Pescador Santirso

Se autoriza, de forma gratuita, a cualquier
persona que ha obtenido una copia de este software y
archivos asociados de documentación (el "Software"), para tratar en el
Software sin restricción, incluyendo sin ninguna limitación en lo que concierne
los derechos para usar, copiar, modificar, fusionar, publicar,
distribuir, sublicenciar, y / o vender copias de este
Software, y para permitir a las personas que usan el Software para
hacerlo, con sujeción a las siguientes condiciones:

El aviso de copyright anterior y este aviso de permiso
se incluirá en todas las copias o partes sustanciales de
este Software.

EL SOFTWARE SE ENTREGA "TAL CUAL", SIN GARANTÍA DE NINGÚN
TIPO, EXPRESA o implícita, no limitado a la GARANTÍAS DE
COMERCIALIZACIÓN, CAPACIDAD DE HACER Y DE NO INFRACCIÓN DE COPYRIGHT. EN NINGÚN
CASO LOS AUTORES O TITULARES DEL COPYRIGHT SERÁN RESPONSABLES DE
NINGUNA RECLAMACIÓN, daños o OTRAS RESPONSABILIDADES,
YA SEA EN UN LITIGIO, agravio o DE OTRO MODO,
DERIVADAS DE, FUERA DE O EN CONEXION CON EL
SOFTWARE SU UTILIZACIÓN U OTRAS OPERACIONES EN EL SOFTWARE.
*/


package lsagpi;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.net.URL;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JEditorPane;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.SwingConstants;
import javax.swing.text.BadLocationException;
import javax.swing.text.StyledEditorKit;

/**
 * Clase de Acerca de.
 * @author Miguel Angel Pescador Santirso
 */
public class AboutBox extends JDialog
{

	//URL url2 = this.getClass().getResource("GPL.txt");
	JTabbedPane tb = new JTabbedPane();
	JPanel botones = new JPanel();
	JEditorPane licencia = new JEditorPane();
	JScrollPane sp = new JScrollPane(licencia);
	JPanel autores = new JPanel();
	JLabel label1 = new JLabel("");
	JLabel label2 = new JLabel("");
	JLabel label3 = new JLabel("");
	JButton aceptar = new JButton("Aceptar");
	ImageIcon imagelogo = new ImageIcon("images\\se.jpg");
	//ImageIcon image5=new ImageIcon("images/zipper5.gif");
	JLabel logo = new JLabel(imagelogo);

    /**
     * Constructor acerca de.
     * @param propietario JFrame desde el que es llamado.
     */
	public AboutBox(JFrame propietario)
	{
		super(propietario, "Acerca de...", true);

		StyledEditorKit ek = new StyledEditorKit();
		try
		{
			FileReader in = null;
			File file = new File("GPL.txt");
			in = new FileReader(file);
			ek.read(in, licencia.getDocument(), 0);
			licencia.setCaretPosition(0);
		}
		catch (IOException r)
		{
		}
		catch (BadLocationException s) { }
		licencia.setEditable(false);
		JLabel autor1 = new JLabel("Miguel Angel Pescador Santirso \n mpescadorsantirso@gmail.com \n Todos los derechos reservados", SwingConstants.CENTER);

		autor1.setHorizontalTextPosition(SwingConstants.CENTER);
		autores.add(autor1);

		//autores.add(image5,SwingConstants.CENTER);
		aceptar.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent e) { dispose(); } });
		tb.addTab("Acerca de...", logo);
		tb.addTab("Licencia", sp);
		tb.addTab("Autores", autores);
		botones.setLayout(new GridLayout(1, 4));
		botones.add(label1);
		botones.add(label2);
		botones.add(label3);
		botones.add(aceptar);
		getContentPane().setLayout(new BorderLayout());
		getContentPane().add("Center", tb);
		getContentPane().add("South", botones);
	}
}