/* LSAGPI                                       */
/* Desarrollado por Miguel Angel Pescador Santirso  */
/* mescadorsantirso@gmail.com                       */

/* LICENCIA X11/MIT
Copyright (c) 2010 Miguel Angel Pescador Santirso

Se autoriza, de forma gratuita, a cualquier
persona que ha obtenido una copia de este software y
archivos asociados de documentación (el "Software"), para tratar en el
Software sin restricción, incluyendo sin ninguna limitación en lo que concierne
los derechos para usar, copiar, modificar, fusionar, publicar,
distribuir, sublicenciar, y / o vender copias de este
Software, y para permitir a las personas que usan el Software para
hacerlo, con sujeción a las siguientes condiciones:

El aviso de copyright anterior y este aviso de permiso
se incluirá en todas las copias o partes sustanciales de
este Software.

EL SOFTWARE SE ENTREGA "TAL CUAL", SIN GARANTÍA DE NINGÚN
TIPO, EXPRESA o implícita, no limitado a la GARANTÍAS DE
COMERCIALIZACIÓN, CAPACIDAD DE HACER Y DE NO INFRACCIÓN DE COPYRIGHT. EN NINGÚN
CASO LOS AUTORES O TITULARES DEL COPYRIGHT SERÁN RESPONSABLES DE
NINGUNA RECLAMACIÓN, daños o OTRAS RESPONSABILIDADES,
YA SEA EN UN LITIGIO, agravio o DE OTRO MODO,
DERIVADAS DE, FUERA DE O EN CONEXION CON EL
SOFTWARE SU UTILIZACIÓN U OTRAS OPERACIONES EN EL SOFTWARE.
*/



package lsagpi;

import java.util.Vector;

/**
 * Evalua una expresion verbal.
 * @author Miguel Angel Pescador Santirso
 */
public class EvaluarExpresion {
    Vector acciones;
    public EvaluarExpresion(Verbo verbo,Elemento elemento, Vector instruccionesglobales, Vector instruccioneslocales){
        System.out.println("Verbo: "+verbo.nombre+"Elemento: "+elemento.nombre);       
        for(int i=0;i<instruccionesglobales.size();i++){
            Accion a=(Accion)instruccionesglobales.get(i);
            if ((verbo.nombre.equals((String)a.instruccion.get(0)))){
                if ((elemento.nombre.equals((String)a.instruccion.get(1)))){
                    acciones=a.acciones;
                    System.out.println("Verbo Elemento");
                    break;
                }else if(((String)a.instruccion.get(1)).equals("*")){
                    acciones=a.acciones;
                    System.out.println("Verbo *");
                    break;
                }
            }else if(((String)a.instruccion.get(0)).equals("*")){
                if ((elemento.nombre.equals((String)a.instruccion.get(1)))){
                    acciones=a.acciones;
                    System.out.println("* Elemento");
                    break;
                }else if(((String)a.instruccion.get(1)).equals("*")){
                    acciones=a.acciones;
                    System.out.println("* *");
                    break;
                }
            }
        }
        for(int i=0;i<instruccioneslocales.size();i++){
            Accion a=(Accion)instruccioneslocales.get(i);
            if ((verbo.nombre.equals((String)a.instruccion.get(0)))){
                if ((elemento.nombre.equals((String)a.instruccion.get(1)))){
                    acciones=a.acciones;
                    System.out.println("Verbo Elemento");
                    break;
                }else if(((String)a.instruccion.get(1)).equals("*")){
                    acciones=a.acciones;
                    System.out.println("Verbo *");
                    break;
                }
            }else if(((String)a.instruccion.get(0)).equals("*")){
                if ((elemento.nombre.equals((String)a.instruccion.get(1)))){
                    acciones=a.acciones;
                    System.out.println("* Elemento");
                    break;
                }else if(((String)a.instruccion.get(1)).equals("*")){
                    acciones=a.acciones;
                    System.out.println("* *");
                    break;
                }
            }
        }
    }
    /**
     * Segundo constructor para instrucciones en elemento
     * @param verbo Verbo que se evalua
     * @param elemento elemento que se evalua
     * @param instruccionesglobales Instrucciones Globales.
     * @param instruccioneslocales Instrucciones de Cuarto.
     * @param instruccionesobjeto Instrucciones de Elemento.
     */
    public EvaluarExpresion(Verbo verbo,Elemento elemento, Vector instruccionesglobales,Vector instruccioneslocales,Vector instruccionesobjeto){
        System.out.println("Verbo: "+verbo.nombre+"Elemento: "+elemento.nombre);
        for(int i=0;i<instruccionesglobales.size();i++){
            Accion a=(Accion)instruccionesglobales.get(i);
            if ((verbo.nombre.equals((String)a.instruccion.get(0)))){
                if ((elemento.nombre.equals((String)a.instruccion.get(1)))){
                    acciones=a.acciones;
                    System.out.println("Verbo Elemento");
                    break;
                }else if(((String)a.instruccion.get(1)).equals("*")){
                    acciones=a.acciones;
                    System.out.println("Verbo *");
                    break;
                }
            }else if(((String)a.instruccion.get(0)).equals("*")){
                if ((elemento.nombre.equals((String)a.instruccion.get(1)))){
                    acciones=a.acciones;
                    System.out.println("* Elemento");
                    break;
                }else if(((String)a.instruccion.get(1)).equals("*")){
                    acciones=a.acciones;
                    System.out.println("* *");
                    break;
                }
            }
        }
        for(int i=0;i<instruccioneslocales.size();i++){
            Accion a=(Accion)instruccioneslocales.get(i);
            if ((verbo.nombre.equals((String)a.instruccion.get(0)))){
                if ((elemento.nombre.equals((String)a.instruccion.get(1)))){
                    acciones=a.acciones;
                    System.out.println("Verbo Elemento");
                    break;
                }else if(((String)a.instruccion.get(1)).equals("*")){
                    acciones=a.acciones;
                    System.out.println("Verbo *");
                    break;
                }
            }else if(((String)a.instruccion.get(0)).equals("*")){
                if ((elemento.nombre.equals((String)a.instruccion.get(1)))){
                    acciones=a.acciones;
                    System.out.println("* Elemento");
                    break;
                }else if(((String)a.instruccion.get(1)).equals("*")){
                    acciones=a.acciones;
                    System.out.println("* *");
                    break;
                }
            }
        }
        for(int i=0;i<instruccionesobjeto.size();i++){
            Accion a=(Accion)instruccionesobjeto.get(i);
            if ((verbo.nombre.equals((String)a.instruccion.get(0)))){
                if ((elemento.nombre.equals((String)a.instruccion.get(1)))){
                    acciones=a.acciones;
                    System.out.println("Verbo Elemento");
                    break;
                }else if(((String)a.instruccion.get(1)).equals("*")){
                    acciones=a.acciones;
                    System.out.println("Verbo *");
                    break;
                }
            }else if(((String)a.instruccion.get(0)).equals("*")){
                if ((elemento.nombre.equals((String)a.instruccion.get(1)))){
                    acciones=a.acciones;
                    System.out.println("* Elemento");
                    break;
                }else if(((String)a.instruccion.get(1)).equals("*")){
                    acciones=a.acciones;
                    System.out.println("* *");
                    break;
                }
            }
        }
    }
    /**
     * Devuelve las acciones a ejecutar dependiendo de la expresion.
     * @return Vector acciones a ejecutar.
     */
    public Vector getAcciones(){
        return acciones;
    }

}
