/* LSAGPI                                       */
/* Desarrollado por Miguel Angel Pescador Santirso  */
/* mescadorsantirso@gmail.com                       */

/* LICENCIA X11/MIT
Copyright (c) 2010 Miguel Angel Pescador Santirso

Se autoriza, de forma gratuita, a cualquier
persona que ha obtenido una copia de este software y
archivos asociados de documentación (el "Software"), para tratar en el
Software sin restricción, incluyendo sin ninguna limitación en lo que concierne
los derechos para usar, copiar, modificar, fusionar, publicar,
distribuir, sublicenciar, y / o vender copias de este
Software, y para permitir a las personas que usan el Software para
hacerlo, con sujeción a las siguientes condiciones:

El aviso de copyright anterior y este aviso de permiso
se incluirá en todas las copias o partes sustanciales de
este Software.

EL SOFTWARE SE ENTREGA "TAL CUAL", SIN GARANTÍA DE NINGÚN
TIPO, EXPRESA o implícita, no limitado a la GARANTÍAS DE
COMERCIALIZACIÓN, CAPACIDAD DE HACER Y DE NO INFRACCIÓN DE COPYRIGHT. EN NINGÚN
CASO LOS AUTORES O TITULARES DEL COPYRIGHT SERÁN RESPONSABLES DE
NINGUNA RECLAMACIÓN, daños o OTRAS RESPONSABILIDADES,
YA SEA EN UN LITIGIO, agravio o DE OTRO MODO,
DERIVADAS DE, FUERA DE O EN CONEXION CON EL
SOFTWARE SU UTILIZACIÓN U OTRAS OPERACIONES EN EL SOFTWARE.
*/



package lsagpi;

import java.util.StringTokenizer;
import java.util.Vector;

/**
 * Clase que parsea los Eventos de la aventura.
 * @author Miguel Angel Pescador Santirso
 */
public class Evento {
 //Comaradores
    final int COLISION=0;
    final int EQ=1;
    final int EQI=2;
    final int EQR=3;
    final int EQS=4;
    final int EQSV=5;
    final int EQV=6;
    final int GE=7;
    final int GEV=8;
    final int GT=9;
    final int GTV=10;
    final int DENTRO=11;
    final int ESJUGADOR=12;
    final int LE=13;
    final int LEV=14;
    final int LT=15;
    final int LTV=16;
    final int NE=17;
    final int NEV=18;
    final int PRESENTE=19;
    final int COGIDO=20;
    final int AND=100;
    final int OR=101;
    final int NOT=102;
//Acciones
final int DI=0;
final int MOVER=1;
final int GIRAR=2;
final int ESPERAR=3;
final int SALIR=4;
final int SELECCIONARPOSICION=5;
final int SELECCIONARTINTA=6;
final int SELECCIONARETIQUETA=7;
final int SELECCIONARJUGADOR=8;
final int DORMIR=9;
final int CAMINAR=10;
final int SALTAR=11;
final int SI=12;
final int ENTONCES=13;
final int OTRO=14;
final int MIENTRAS=15;
final int PARA=16;
    Vector condicion=new Vector();
    Vector acciones=new Vector();
    public Evento(String definicion){
        boolean nopasar=true;
        StringTokenizer st = new StringTokenizer(definicion,"\n",true);
        System.out.println(definicion);
        //nombre=st.nextToken();
        while (st.hasMoreTokens())
		{
            String cadena=st.nextToken();
            if(nopasar==false){
                cadena=st.nextToken();
            }else{
                nopasar=false;
            }
            if(cadena.indexOf("SI")!=-1){
                System.out.println("Bloque SI");

                String num=new String("");
                Vector expresion=new Vector();
                if(cadena.indexOf("SI")!=-1 && cadena.indexOf("{")!=-1){}
                else{cadena=st.nextToken();}
                StringTokenizer num_tok=new StringTokenizer(cadena," ");
                /* Condicion */
                while(num_tok.hasMoreTokens()){
                    num=num_tok.nextToken();
                    if(num.equals("{") && num_tok.hasMoreTokens()){
                        System.out.println("entra");
                        //expresion.add(SI);
                        while(num_tok.hasMoreTokens()){
                            String num2=num_tok.nextToken().trim();
                            if(num2.equals("COLISION")){
                                condicion.add(COLISION);}
                            else if(num2.equals("EQ")){
                                condicion.add(EQ);}
                            else if(num2.equals("EQR")){
                                condicion.add(EQR);}
                            else if(num2.equals("EQS")){
                                condicion.add(EQS);}
                            else if(num2.equals("EQSV")){
                                condicion.add(EQSV);}
                            else if(num2.equals("EQV")){
                                condicion.add(EQV);}
                            else if(num2.equals("GE")){
                                condicion.add(GE);}
                            else if(num2.equals("GEV")){
                                condicion.add(GEV);}
                            else if(num2.equals("GT")){
                                condicion.add(GT);}
                            else if(num2.equals("GTV")){
                                condicion.add(GTV);}
                            else if(num2.equals("DENTRO")){
                                condicion.add(DENTRO);}
                            else if(num2.equals("ESJUGADOR")){
                                condicion.add(ESJUGADOR);}
                            else if(num2.equals("LE")){
                                condicion.add(LE);}
                            else if(num2.equals("LEV")){
                                condicion.add(LEV);}
                            else if(num2.equals("LT")){
                                condicion.add(LT);}
                            else if(num2.equals("LTV")){
                                condicion.add(LTV);}
                            else if(num2.equals("NE")){
                                condicion.add(NE);}
                            else if(num2.equals("NEV")){
                                condicion.add(NEV);}
                            else if(num2.equals("PRESENTE")){
                                condicion.add(PRESENTE);}
                            else if(num2.equals("COGIDO")){
                                condicion.add(COGIDO);}
                            else{condicion.add(num2);}
                        }
                    }else{
                        cadena=st.nextToken();
                        while(cadena.indexOf("{")!=-1 || cadena.trim().equals("\n"))
                            cadena=st.nextToken();
                        System.out.println("entra2");
                        cadena=st.nextToken();
                        System.out.println(cadena);
                        StringTokenizer num2_tok=new StringTokenizer(cadena);
                        //expresion.add(SI);
                        while(num2_tok.hasMoreTokens()){
                            String num2=num2_tok.nextToken().trim();
                            if(num2.equals("COLISION")){
                                condicion.add(COLISION);}
                            else if(num2.equals("EQ")){
                                condicion.add(EQ);}
                            else if(num2.equals("EQR")){
                                condicion.add(EQR);}
                            else if(num2.equals("EQS")){
                                condicion.add(EQS);}
                            else if(num2.equals("EQSV")){
                                condicion.add(EQSV);}
                            else if(num2.equals("EQV")){
                                condicion.add(EQV);}
                            else if(num2.equals("GE")){
                                condicion.add(GE);}
                            else if(num2.equals("GEV")){
                                condicion.add(GEV);}
                            else if(num2.equals("GT")){
                                condicion.add(GT);}
                            else if(num2.equals("GTV")){
                                condicion.add(GTV);}
                            else if(num2.equals("DENTRO")){
                                condicion.add(DENTRO);}
                            else if(num2.equals("ESJUGADOR")){
                                condicion.add(ESJUGADOR);}
                            else if(num2.equals("LE")){
                                condicion.add(LE);}
                            else if(num2.equals("LEV")){
                                condicion.add(LEV);}
                            else if(num2.equals("LT")){
                                condicion.add(LT);}
                            else if(num2.equals("LTV")){
                                condicion.add(LTV);}
                            else if(num2.equals("NE")){
                                condicion.add(NE);}
                            else if(num2.equals("NEV")){
                                condicion.add(NEV);}
                            else if(num2.equals("PRESENTE")){
                                condicion.add(PRESENTE);}
                            else if(num2.equals("COGIDO")){
                                condicion.add(COGIDO);}
                            else{condicion.add(num2);}
                        }
                    }

                }
                System.out.println(cadena);
                cadena=st.nextToken();
                System.out.println(cadena);
                while(cadena.indexOf("}")!=-1 || cadena.trim().isEmpty())
                    cadena=st.nextToken();
                /* Primera Opcion: Obligatoria */
                if (cadena.indexOf("ENTONCES")!=-1){
                    System.out.println("Bloque ENTONCES");
                    cadena=st.nextToken();
                    String cadenaEntonces=new String("");
                    while(cadena.indexOf("{")==-1)
                        cadena=st.nextToken();
                    int contador=0;
                    while(contador!=-1){
                        cadena=st.nextToken();
                        if(cadena.indexOf("{")!=-1){
                            contador++;
                            cadenaEntonces+=cadena;
                        }else if(cadena.indexOf("{")!=-1 && cadena.indexOf("}")!=-1){
                            cadenaEntonces+=cadena;
                        }else if(cadena.indexOf("}")!=-1){
                            contador--;
                            cadenaEntonces+=cadena;
                        }else{
                            cadenaEntonces+=cadena;
                        }
                    }
                    System.out.println(cadenaEntonces);
                    Accion a=new Accion(cadenaEntonces);
                    expresion.add(a.acciones);

                }
                if(st.hasMoreTokens()){
                    cadena=st.nextToken();
                }else{
                    break;
                }
                while((cadena.indexOf("}")!=-1 || cadena.trim().isEmpty())&& st.hasMoreTokens())
                    cadena=st.nextToken();
                /* Segunda Opción: Optativa */
                if (cadena.indexOf("OTRO")!=-1){
                     System.out.println("Bloque OTRO");
                    cadena=st.nextToken();
                    String cadenaEntonces=new String("");
                    if(cadena.indexOf("{")!=-1)
                        cadena=st.nextToken();
                    int contador=0;
                    while(contador!=-1){
                        cadena=st.nextToken();
                        if(cadena.indexOf("{")!=-1){
                            contador++;
                            cadenaEntonces+=cadena;
                        }else if(cadena.indexOf("{")!=-1 && cadena.indexOf("}")!=-1){
                            cadenaEntonces+=cadena;
                        }else if(cadena.indexOf("}")!=-1){
                            contador--;
                            cadenaEntonces+=cadena;
                        }else{
                            cadenaEntonces+=cadena;
                        }
                    }
                    System.out.println(cadenaEntonces);
                    Accion a=new Accion(cadenaEntonces);
                    expresion.add(a.acciones);

                }else{nopasar=true;}
                for(int i=0;i<expresion.size();i++)
                    for (int j=0;j<((Vector)expresion.get(i)).size();j++)
                    acciones.add(((Vector)expresion.get(i)).get(j));
            }

        }


    }
}
